#ifndef HKLLISTDIALOG_H
#define HKLLISTDIALOG_H

#include <QDialog>
#include <QStandardItemModel>
#include <QSortFilterProxyModel>
#include <QAbstractButton>

class MainWindow;

typedef struct {
    int   hkl[3];
    int   m;
    float tthd;
    float d;
    float fo;
    float fc;
    int   ph;
    int   idph;
} c_hkl_info;

namespace Ui {
class HklListDialog;
}

class HklListDialog : public QDialog
{
    Q_OBJECT

public:
    explicit HklListDialog(MainWindow *mw);
    ~HklListDialog();
    void setDialog(c_hkl_info hklInfo[], int nHkl, int vis[]);

private slots:
    void on_ftypeComboBox_currentIndexChanged(int index);
    void on_buttonBox_clicked(QAbstractButton *button);

private:
    Ui::HklListDialog *ui;
    QStandardItemModel *hklListModel;
    QSortFilterProxyModel *hklListProxyModel;
    MainWindow *mWindow;
    enum {FVALUE, FSQUARE};
    int ftype;
    void createHklListModel();
    void setHklTableView();
    void markSelectedHkl();
    void updateFtype(int column, int type, QString columnTitle);
};

#endif // HKLLISTDIALOG_H
