#ifndef MOPACDIALOG_H
#define MOPACDIALOG_H

#include "models.h"
#include <QDialog>
#include <QAbstractButton>

namespace Ui {
class MopacDialog;
}

#if defined(JAV_WIDGET)
class CrystalViewWidget;
#else
class JavWindow;
#endif

class MopacDialog : public QDialog
{
    Q_OBJECT

public:
    explicit MopacDialog(QWidget *parent = nullptr);
    void openMOPAC(int whichModel);
    QString getOutFileName() const;
    ~MopacDialog();

private slots:
    void on_previewButton_clicked();
    void on_programButton_clicked();    
    void on_buttonBox_clicked(QAbstractButton *button);
    void updatePreview(int index);
    void titleChanged(QString text);
    void previewChanged();
    void setEnabled(bool state);

private:
    Ui::MopacDialog *ui;
    Model *md;
    int wm;
    QString outFileName;
#if defined(JAV_WIDGET)
    CrystalViewWidget *jav;
#else
    JavWindow *jav;
#endif
    void findMOPAC();
    void FillPreview();
};

#endif // MOPACDIALOG_H
