#ifndef MYPROXYMODEL_H
#define MYPROXYMODEL_H

#include <QStandardItemModel>
#include <QSortFilterProxyModel>

class MyProxyModel : public QSortFilterProxyModel
{
    Q_OBJECT

public:
    MyProxyModel(QObject *parent=0);
    void setColumnTypes(int n, const char *tipi) {for(int i=0; i<n; i++) columnType[i]=tipi[i];}
    void setColumnForSort(int n) {columnForSort=n;}

protected:
    bool lessThan(const QModelIndex &left, const QModelIndex &right) const override;

private:
    QStandardItemModel *modelAtoms=nullptr;
    char columnType[20];
    int  columnForSort;
    bool isAlphaColumn(int col) const {return (columnType[col] == 'a');}
    bool isIntColumn(int col) const {return (columnType[col] == 'i');}
    bool isFloatColumn(int col) const {return (columnType[col] == 'f');}
    bool isDoubleColumn(int col) const {return (columnType[col] == 'd');}
    bool isSpecialColumn(int col) const {return (columnType[col] == 's');}
};

#endif
