#ifndef PAIRDIST_H
#define PAIRDIST_H

#include <QDialog>
#include "grafico.h"
#include "pairdistsettings.h"

namespace Ui {
class PairDist;
}
using namespace GraphicSpace;

class PairDist : public QDialog
{
    Q_OBJECT

public:
    explicit PairDist(QWidget *parent = 0);
    ~PairDist();
    static QString MessForSB(QPointF p);
    QString StatusMessage(QPointF p);
    void FillPDFDlg(int whichModel, QString filename);
    void DoPDF(float x[], float y[], int num);

private:
    Ui::PairDist *ui;
    pdf_option_type m_pdf;
    Grafico *m_Scene;
    int m_Kmodel;
    QString m_FileName;
    PairDistSettings *mPDFsett;
    QStatusBar *mStatusBar;

protected:
    void resizeEvent(QResizeEvent *) override;

private slots:
    void on_exportButton_clicked();
    void on_settingsButton_clicked();
    void on_resetButton_clicked();
    void on_closeButton_clicked();
};

#endif // PAIRDIST_H
