#ifndef POWDERDATAWIDGET_H
#define POWDERDATAWIDGET_H

#include "dataset.h"

#include <QWidget>

namespace Ui {
class PowderDataWidget;
}

class PowderDataWidget : public QWidget
{
    Q_OBJECT

public:
    explicit PowderDataWidget(QWidget *parent = nullptr);
    ~PowderDataWidget();

    void setData(const dataset_t &data, const BackgroundSettings &backSettings);
    void getData(dataset_t &data);
    bool hasParameterToRefine();
    bool hasParameterChanged();
    void setRefineEnabled(bool enable);

private slots:
    void onModifyBackgroundButtonClicked();
    void setParameterChanged();

private:
    Ui::PowderDataWidget *ui;
    void setBackgroundLabel(const BackgroundSettings &backSettings);
    bool parameterChanged;
};

#endif // POWDERDATAWIDGET_H
