#ifndef PROFILEFUNCTIONWIDGET_H
#define PROFILEFUNCTIONWIDGET_H

#include "crystaldata.h"
#include "dataset.h"

#include <QWidget>
#include <QHash>
#include <QLineEdit>

namespace Ui {
class ProfileFunctionWidget;
}

class ProfileFunctionWidget : public QWidget
{
    Q_OBJECT

public:
    explicit ProfileFunctionWidget(QWidget *parent = nullptr);
    ~ProfileFunctionWidget();
    void setData(int phaseId, const crydata::crystal_t &cryst);
    void getData(int phaseId, crydata::crystal_t &cryst);
    bool hasParameterToRefine();
    bool hasParameterChanged();
    void setRefineEnabled(bool enable);

private slots:
    void on_functionTypeComboBox_currentIndexChanged(int index);

private:
    Ui::ProfileFunctionWidget *ui;
    enum ProfileFunctionType {PEARSON7, PVOIG, TCHZ};
    QHash<QLineEdit *, bool> lineEditChanged;
    int typeFunction;
    bool functionTypeChanged;
    //bool textChangedEnabled;
    void setWidgetData(const crydata::crystal_t &cryst, c_profile_function prof[]);
    void getWidgetData(crydata::crystal_t &cryst, c_profile_function prof[]);
    void connectLineEdit(QLineEdit *lineEdit);
    bool hasFunctionValueChanged(int typefun);
};

#endif // PROFILEFUNCTIONWIDGET_H
