#ifndef SPACEGDIALOG_H
#define SPACEGDIALOG_H

#include <QDialog>
#include <QAbstractButton>

namespace Ui {
class SpacegDialog;
}

class SpacegDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SpacegDialog(QWidget *parent = nullptr);
    ~SpacegDialog();
    void setData(double cell[6], int sgIndex, const QString &spg, const QString &content, int findspace);
    QString getContent() const;
    int getSpaceGroup(QString &spg) const;
    void getCellParameters(double cell[6]) const;
    int getFindSpace() const;

private slots:
    void on_findSgCheckBox_toggled(bool checked);
    void enableOkButton();

private:
    Ui::SpacegDialog *ui;
    void accept() override;
};

#endif // SPACEGDIALOG_H
