#ifndef SYMMETRYWIDGET_H
#define SYMMETRYWIDGET_H

#include <QWidget>

namespace Ui {
class SymmetryWidget;
}

class SymmetryWidget : public QWidget
{
    Q_OBJECT

public:
    explicit SymmetryWidget(QWidget *parent = nullptr);
    ~SymmetryWidget();
    void setData(double cell[6], int sgIndex, const QString &spg);    
    void enableSpacegWidget(bool enable);
    double cellVolume() const;
    int getSpaceGroup(QString &spg) const;
    void getCellParameters(double cell[6]) const;
    bool isValidSpaceGroup() const;
    bool isValidCell() const;

signals:
    void spaceWidgetChanged(const QString &spg);
    void cellWidgetChanged();

private:
    Ui::SymmetryWidget *ui;
};

#endif // SYMMETRYWIDGET_H
