!corr! ----------------------------------------------------------------------
!corr      module util_interop
!corr
!corr      implicit none
!corr
!corr      contains
!corr
!corr      integer function home_location(hfolder)
!corr!
!corr!     Return the home directory. This is equal to $HOME on linux
!corr!
!corr      use iso_c_binding
!corr      use strutil
!corr
!corr      interface
!corr      function HomeLocationC(dirnam,lend)
!corr     *bind(C,name="HomeLocationC")
!corr      use iso_c_binding
!corr      character(c_char), dimension(*) :: dirnam
!corr      integer(c_int)                  :: lend
!corr      integer(c_int)                  :: HomeLocationC
!corr      end function HomeLocationC
!corr      end interface
!corr!
!corr      integer get_configdir
!corr      character(len=:), allocatable, intent(out) :: hfolder
!corr      character(c_char), dimension(256)          :: hfolder1
!corr      integer                                    :: lend
!corr!
!corr      home_location = HomeLocationC(hfolder1,lend)
!corr      hfolder = toFortranString(hfolder1,lend)
!corr!
!corr      end function home_location
!corr
!corr!-----------------------------------------------------------------------
!corr
!corr      subroutine set_current_files(fileIn,fileOut)
!corr!
!corr!     Set name of input and output file for GUI
!corr!
!corr      use strutil
!corr      interface
!corr         subroutine setCurrentFiles(c_fileIn, c_fileOut)
!corr     *   bind(C,name="setCurrentFiles")
!corr         use iso_c_binding
!corr         character(c_char) :: c_fileIn(*), c_fileOut(*)
!corr         end subroutine setCurrentFiles
!corr      end interface
!corr      character(len=*), intent(in) :: fileIn, fileOut
!corr
!corr      call setCurrentFiles(f_to_c(fileIn),f_to_c(fileOut))
!corr
!corr      end subroutine set_current_files
!corr
!corr!-----------------------------------------------------------------------
!corr
!corr      function get_program_directory() result(dir)
!corr!
!corr!     Return the application directory path
!corr!
!corr      use iso_c_binding
!corr      use strutil
!corr
!corr      interface
!corr         subroutine getProgramDir(dirnam,lend)
!corr     *   bind(C,name="getProgramDir")
!corr         use iso_c_binding
!corr         character(c_char) :: dirnam(*)
!corr         integer(c_int)    :: lend
!corr         end subroutine getProgramDir
!corr      end interface
!corr
!corr      character(len=:), allocatable     :: dir
!corr      character(c_char), dimension(256) :: dir1
!corr      integer(c_int)                    :: lend
!corr
!corr      call getProgramDir(dir1,lend)
!corr      dir = toFortranString(dir1,lend)
!corr
!corr      end function get_program_directory
!corr
!corr      end module
!corr
!-----------------------------------------------------------------------
!     List of subroutines (S) & functions (F) in this file
!-----------------------------------------------------------------------
!
!-- Routines related to graphic
!
! S    InitGraphics(iz)         !mrmrmr obsoleta
! S    PassaParametro(iquale,str)
! S    OpenWindow(str, iz)
! S    StartMainLoop(iflag)
! S    EnableSingleIteration(iflag)
! S    DoSingleIteration()
! S    SetWindowTitle (string)
! S    AllocaColori()
! S    PrintMess(Message)
! S    ClearMessage
! S    PassaSpecie(str,iflag,nk)
! S    Beep(i1,i2)
! S    NewPage
! S    SetColor(iColor)
! S    SetRGBColor(ir, ig, ib)
! S    Punto (ix1, iy1, iColor)
! S    Linea (ix, iy, ix2, iy2, iColor)
! S    Linea_dash (ix, iy, ix2, iy2, iColor)
! S    LineaSpessa(ix1, iy1, ix2, iy2, iColor, iRaggio)
! S    LineaSfumata(ix1, iy1, ix2, iy2, iColor, iRaggio)
! S    Rettangolo (ix1, iy1, ix2, iy2, ic1, ic2)
! S    Poligono (numVert, iColore, iFill)
! S    Star(X11,Y11)
! S    Croce (ix1, iy1, iSize, iColor, itypecross)
! S    Cerchio (ix1, iy1, Radius, iColor, IfFill, iFillColor)
! S    Cerchio_dash (ix, iy, ir, iColor)
! S    Ellisse_dash (ix, iy, AsseX, AsseY, Start, Len, iColor)
! S    Arco_dash (ix, iy, ir, iniz, ifin, iColor)
! S    MettiPixmap(string, ix, iy)
! S    Palla(ix, iy, iq, iraggio, ic1, ixlux, iylux)
! S    Togo(iRaggio, iC1, iC2)
! S    AllocaGBuffer(iflag)
! S    DrawLabel (ix1, iy1, string, iColor)
! S    DrawLabelA (ix1, iy1, string, iColor)
! F    LenInPix(str)                          Lenght of a string in pixels
! F    LenInPix2(str,nChars)                  Lenght of a string in pixels
! S    text_mode(flag)
!
!-- Files related routines
!
! S    CheckRecordLength
! F    jopen(ncsu,name,istat,iform,ier)       Open sequential file
! F    kopen(ncsu,name,nlen,itype,ier)        Open direct access file
!
!-- Sort routines
!
! S    sortz(lind,numb,iblk,jump)
! S    sortz_dyn(vettore,idim,lind,numb,iblk,jump)
! S    sort3 (alf,iorde,   numb)
! S    sortall(isort,x,numb)
! S    sort3_int(ialf, iorde, numb)
! S    unpak3Sir(index,kod1,kod2,ifaz)
! S    besse(xx,vec)
! S    unpack (index,ih,kk,il)
!
!-- Time & date routines
!
! S    CPUTime(string)
! S    CPUTime0(string)
! S    sirtime(string,lstring)
! S    sirdate(string,lstring)
!
!-- String related routines
!
! S    ucase(line)                       Convert a string in upper case
! S    lcase(line)                       Convert a string in lower case
! S    filtra(string)                    Eliminates ^M in a string
! S    getnum(linei,vet,ivet,iv,iopt)    Get numerical values from a string
! S    shift(string,lenp)                Left shift of a string
! S    cutst(string,lens,dire,lend)      Cut a string with respect to the first blank
!                                        Leftmost string in dire, remainder in string
! S    CentraStr(icode,nchar,line,str)   Center a string
! S    ltrim(tmp)
! S    CutStr(tmp, iz)                   Cut a string with respect to the first blank
! F    Valore(string)                    Numrical value of a string
! F    Lung(Stringa)                     Number of chars in a string
! S    StandardSPG(String,ier)           Make Space Group Symbol standard
! S    OneBlankOnly(String)              Only one blank allowed between items
!
!-- Numeric routines
! F    bes(x)                            Bessel function
! F    besinv(y)                         Inverse of a Bessel function
!
!-- Array manipulation routines
! S    MoltMatVec(a, b, c)               matrix * vector
! S    MoltVecMat(a, b, c)               vector * matrix
! S    MoltMatMat(a, b, c)               matrix * matrix
!-----------------------------------------------------------------------
!     GRAPHIC PRIMITIVES
!-----------------------------------------------------------------------
!qt      subroutine InitGraphics(iz)
!qt      USE Molcom
!qt! ---
!qt      iz = 0
!qt      ind = -1
!qt      icolor=1
!qt      call graphs(iz,ind,' ',icolor,icolor)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
!qt      subroutine PassaParametro(iquale,str)
!qt      USE Molcom
!qt! ---
!qt      character*(*) str
!qt!
!qt      ind = iquale*1000
!qt      iz = 0
!qt      icolor=0
!qt      call graphs(iz,ind,str,icolor,icolor)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
!corr      subroutine OpenWindow(str, iz)
!corr      USE Molcom
!corr! ---
!corr      character*(*) str
!corr!
!corr      iz = 0
!corr      ind = 1
!corr      icolor=1
!corr      call graphs(iz,ind,str,icolor,icolor)
!corr      write(0,*)'FIX OpenWindow called by scr0 (screen.f)'
!corr!
!corr      return
!corr      end
!-----------------------------------------------------------------------
!qt      subroutine StartMainLoop(iflag)
!qt      USE Molcom
!qt! ---
!qt      iz = 0
!qt      ind = 999
!qt      icol0 = 0
!qt      call graphs(iz, ind, ' ', iflag, icol0)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
!corr      subroutine EnableSingleIteration(iflag)
!corr      USE Molcom
!corr!
!corr      ind = 85
!corr      iot = 0
!corr      call graphs(iflag, ind,' ', iot, iot)
!corr!
!corr      return
!corr      end
!-----------------------------------------------------------------------
!corr      subroutine DoSingleIteration()
!corr      USE Molcom
!corr!
!corr      if (kscreen.eq.0) then
!corr         return
!corr      end if
!corr      ind = 86
!corr      iot = 0
!corr      iz = 0
!corr      call graphs(iz, ind,' ', iot, iot)
!corr!
!corr      return
!corr      end
!-----------------------------------------------------------------------
!qt      subroutine AllocaColori()
!qt      USE Molcom
!qt!
!qt      ind = 83
!qt      iot = 0
!qt      iz = 0
!qt      call graphs(iz, ind,' ', iot, iot)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
!!!corr      subroutine PassaSpecie(str,iflag,nk)
!!!corr      USE Molcom
!
!!!corr      character*(*) str

!!!corr      iColor = nk
!!!corr      ind = 18
!!!corr      call graphs(iz, ind, str, iColor, iflag)
!
!!!corr      return
!!!corr      end
!-----------------------------------------------------------------------
!qt      subroutine Rettangolo (ix1, iy1, ix2, iy2, ifill)
!qt      USE Molcom
!qt! ---
!qt      character *1 string
!qt! ---
!qt      if (ix1.le.ix2) then
!qt         ixv(1) = ix1
!qt         ixv(2) = ix2
!qt      else
!qt         ixv(1) = ix2
!qt         ixv(2) = ix1
!qt      endif
!qt      if (iy1.le.iy2) then
!qt         iyv(1) = iy1
!qt         iyv(2) = iy2
!qt      else
!qt         iyv(1) = iy2
!qt         iyv(2) = iy1
!qt      endif
!qt      kx = ixv(2) - ixv(1)
!qt      ky = iyv(2) - iyv(1)
!qt      ic2 = ifill
!qt      if (ic2>=0 .and. kx*ky == 0) then
!qt          ic2 = -1   ! non riempire il rettangolo se kx o ky sono 0
!qt      endif
!qt      ind = 17
!qt      iz = 0
!qt!mrmr
!qt      string = ' '
!qt      ic1 = 0
!qt!mrmr
!qt      call graphs(iz,ind,string,ic1,ic2)
!qt!corra*     if (kx.gt.0.and.ky.gt.0) then
!qt!corra          ind = 17
!qt!corra          iz = 0
!qt!corra          call graphs(iz,ind,string,ic1,ic2)
!qt!corra*     else
!qt!corra*         ind = 2
!qt!corra*         iz = 0
!qt!corra*         call graphs(iz,ind,string,ic1,ic2)
!qt!corra*     endif
!qt!
!qt      return
!qt      end
! ----------------------------------------------------------------------
!      subroutine SetWindowTitle (string)
!      USE Molcom
!! ---
!      character*(*) string
!!
!      write(0,*)'FIX SetWindowTitle'
!!corr      ind = 81
!!corr      iz = 0
!!corr      idum = 0
!!corr      idum = 0
!!corr      call graphs(iz,ind,string,idum, idum)
!!
!      return
!      end
! ----------------------------------------------------------------------
      subroutine Poligono (numVert, iFill)
      USE Molcom
! ---
      if (iFill.eq.0) then
          ind = 14
      else if (iFill.eq.1) then
         ind = 15
      else if (iFill.eq.-1) then
         ind = 16
      end if
!qt      iColore = 0
!qt      call graphs(numVert,ind,' ',iColore,iColore)
      return
      end
! ----------------------------------------------------------------------
      subroutine ClearMessage
!
      call PrintMess(' ')
!
      return
      end
!-----------------------------------------------------------------------
!qt      subroutine Beep(i1,i2)
!qt      USE Molcom
!qt!
!qt      if (kscreen.eq.0) then
!qt         return
!qt      end if
!qt      ind = 80
!qt      iz = 0
!qt      ixv(1) = i1
!qt      iyv(1) = i2
!qt      call graphs(iz,ind,' ',icolor,icolor)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
      subroutine PrintMess(Message)
      USE Molcom, only: kscreen
      USE interop_cpp_for
      USE strutil, only: toCString
      implicit none 
      character(len=*),intent(in) :: Message
!
      if (kscreen.eq.0) return
!
      call cprintMessage(toCString(Message))
!
      end subroutine PrintMess
! -----------------------------------------------------------------
!qt      subroutine Linea (ix, iy, ix2, iy2, lwidth)
!qt      USE Molcom
!qt      implicit none
!qt      integer, intent(in) :: ix,iy,ix2,iy2,lwidth
!qt      integer :: ind,iColor,iz
!qt!
!qt      ixv(1)=ix
!qt      ixv(2)=ix2
!qt      iyv(1)=iy
!qt      iyv(2)=iy2
!qt      ind = 3
!qt      !iColor = 0
!qt      call graphs(iz, ind, ' ', lwidth, lwidth)
!qt!
!qt      return
!qt      end
!qt!-----------------------------------------------------------------------
!qt      subroutine Linea_dash (ix, iy, ix2, iy2, lwidth)
!qt      USE Molcom
!qt      implicit none
!qt      integer, intent(in) :: ix,iy,ix2,iy2,lwidth
!qt      integer :: ind,iColor,iz
!qt!
!qt      ixv(1)=ix
!qt      ixv(2)=ix2
!qt      iyv(1)=iy
!qt      iyv(2)=iy2
!qt      ind = 5
!qt      iColor = 0
!qt      call graphs(iz, ind, ' ', iColor, iColor)
!qt!
!qt      return
!qt      end
!qt!-----------------------------------------------------------------------
!qt      subroutine Cerchio_dash (ix, iy, ir)
!qt      USE Molcom
!qt!
!qt      ixv(1)=ix - ir
!qt      iyv(1)=iy - ir
!qt      iz = 2*ir
!qt      ind = 12
!qt      iColor = 0
!qt      call graphs(iz, ind,' ', iColor, iColor)
!qt      call zflush
!qt!
!qt      return
!qt      end
!qt!-----------------------------------------------------------------------
!qt      subroutine Ellisse_dash (ix, iy, AsseX, AsseY, Start, Len)
!qt      USE Molcom
!qt      integer AsseX, AsseY, Start, Len
!qt!
!qt      ixv(1) = ix - AsseX
!qt      iyv(1) = iy - AsseY
!qt      ixv(2) = AsseX * 2
!qt      iyv(2) = AsseY * 2
!qt      ixv(3) = Start
!qt      iyv(3) = Len
!qt      ind = 22
!qt      iColor = 0
!qt      call graphs(iz, ind, ' ', iColor, iColor)
!qt      call zflush
!qt!
!qt      return
!qt      end
!qt!-----------------------------------------------------------------------
!qt      subroutine Arco_dash (ix, iy, ir, iniz, ifin)
!qt      USE Molcom
!qt!
!qt      ixv(1)=ix - ir
!qt      iyv(1)=iy - ir
!qt      ixv(2)= iniz
!qt      iyv(2)= ifin
!qt      iz = 2*ir
!qt      ind = 13
!qt      iColor = 0
!qt      call graphs(iz, ind, ' ', iColor, iColor)
!qt      call zflush
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
      subroutine text_mode(flag)
      USE prognames, only: package_alt_name
      USE Molcom, only: jscreen
      implicit none
      integer flag
      integer :: ind, icolor !, iz
!
      if (flag.eq.1) then
          write(0, '(" Thanks for using ", a)')package_alt_name
          write(0, *) 'Bye'
      endif
      if (jscreen.ne.0) then
          ind = 0
          icolor = 1
!comment temporaneamente per expo2          jscreen = 0
!qt          call graphs(iz,ind,' ',flag,icolor)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SetColor(iColor)
      USE Molcom
!
!corr      icoloresettato = iColor
      ind = 8
      ix=0
      iy=0
!qt      call graphs(iz,ind," ",iColor,iColor)
!
      return
      end
!-----------------------------------------------------------------------
!qt      subroutine SetRGBColor(ir, ig, ib)
!qt!
!qt      call SetColor_asRGB(ir, ig, ib)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
      subroutine MettiPixmap(string, ix, iy)
      USE Molcom
      character*(*) string
!
      ixv(1)=ix
      iyv(1)=iy
      ind = 19
      iz = 0
      idum = 0
!qt      call graphs(iz,ind,string,idum,idum)
!
      return
      end
!-----------------------------------------------------------------------
!qt      subroutine Palla(ix, iy, iq, iraggio, ic1, ixlux, iylux)
!qt      USE Molcom
!qt!
!qt      ixv(1) = ix 
!qt      iyv(1) = iy
!qt      ixv(2) = iraggio
!qt      iyv(2) = iq  
!qt      ixv(3) = ixlux
!qt      iyv(3) = iylux
!qt      ind = 31
!qt      iz = 0
!qt      call graphs(iz,ind,char(0),ic1,ic1)
!qt!
!qt      return
!qt      end
! -----------------------------------------------------------------
!qt      subroutine AllocaGBuffer(iflag)
!qt      USE Molcom
!qt!      character*80 string
!qt!
!qt      ic1 = 1
!qt      iz = iflag
!qt      ind = 30
!qt      call graphs(iz,ind,' ',ic1, ic1)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
!qt      subroutine Cerchio (ix1, iy1, Radius, IfFill)
!qt      USE Molcom
!qt      integer Radius
!qt!
!qt!     X , Y  :  Center Coordinates
!qt!     Radius :  Circle Radius
!qt!     IfFill = 0 don't fill    = -1  Fill
!qt!
!qt      ixv(1) = ix1 - Radius
!qt      iyv(1) = iy1 - Radius
!qt      iz = 2 * Radius
!qt      iColor = 0
!qt      iFillcolor = 0
!qt      if (IfFill .ne. 0) then
!qt         ind = 11
!qt         call graphs(iz,ind,' ',iColor,iFillcolor)
!qt      else
!qt         ind = 10
!qt         call graphs(iz,ind,' ',iColor,iColor)
!qt      end if
!qt!
!qt      return
!qt      end
!qt! -----------------------------------------------------------------
!qt      subroutine Punto (ix1, iy1)
!qt      USE Molcom
!qt!
!qt!     X , Y  :  Point Coordinates
!qt!
!qt      ixv(1) = ix1 
!qt      iyv(1) = iy1
!qt      iz = 1
!qt      ind = 2
!qt      iColor = 0
!qt      call graphs(iz,ind,' ',iColor,icolor)
!qt!
!qt      return
!qt      end
! -----------------------------------------------------------------
!qt      subroutine DrawLabel (ix1, iy1, string, size)
!qt      USE Molcom
!qt!
!qt      character*(*) string
!qt      integer size
!qt!
!qt!     ix1 , iy1 :  Label Coordinates
!qt!     string    :  Label text
!qt!
!qt      ixv(1) = ix1
!qt      iyv(1) = iy1
!qt      iz = size
!qt      ind = 90
!qt      iColor = 0
!qt      call graphs(iz,ind,string,iColor,iColor)
!qt!
!qt      return
!qt      end
! -----------------------------------------------------------------
      subroutine DrawLabelA (ix1, iy1, string)
      USE Molcom
      character*(*) string
!
!     ix1 , iy1 :  Label Coordinates
!     string    :  Label text
!
      ixv(1) = ix1 
      iyv(1) = iy1
      iz = Lung(string)
      ind = 9
      iColor = 0
!qt      call graphs(iz,ind,string,iColor,iColor)
!
      return
      end
!------------------------------------------------------------------
!qt      subroutine DrawLabelV(ix1, iy1, string, size)
!qt      USE Molcom
!qt!
!qt!-- Draw a vertical string
!qt      character*(*) string
!qt      integer size
!qt!
!qt!     ix1 , iy1 :  Label Coordinates
!qt!     string    :  Label text
!qt!
!qt      ixv(1) = ix1
!qt      ixv(2) = 0
!qt      iyv(1) = iy1
!qt      iz = size
!qt      ind = 29
!qt      iColor = 0
!qt      call graphs(iz,ind,string,iColor,iColor)
!qt!
!qt      return
!qt      end
!------------------------------------------------------------------
!qt      subroutine Croce (ix1, iy1, iSize, itypecross)
!qt      USE Molcom
!qt      integer Radius
!qt!
!qt!     X , Y  :  Center Coordinates
!qt!     iSize : Cross Size
!qt!     itypecross : =0 -> croce normale, =1 -> croce ruotata
!qt!
!qt      ixv(1) = ix1 
!qt      iyv(1) = iy1
!qt      iz = iSize
!qt      iColor = 0
!qt      if (itypecross == 0) then
!qt          ind = 33 
!qt          call graphs(iz,ind,' ',iColor,iColor)
!qt      else
!qt          ind = 34 
!qt          call graphs(iz,ind,' ',iColor,iColor)
!qt      endif
!qt!
!qt      return
!qt      end
! -----------------------------------------------------------------
!qt      subroutine LineaSpessa(ix1, iy1, ix2, iy2, iRaggio)
!qt      USE Molcom
!qt!
!qt      ixv(1) = ix1
!qt      ixv(2) = ix2
!qt      iyv(1) = iy1
!qt      iyv(2) = iy2
!qt      iz = 1
!qt      iPen = iRaggio * 2
!qt      ind = 4
!qt      iColor = 0
!qt      call graphs(iz,ind,' ',iColor,iPen)
!qt!
!qt      return
!qt      end
!qt! -----------------------------------------------------------------
!qt      subroutine LineaSpessa2(ix1, iy1, ix2, iy2, iRaggio)
!qt      USE Molcom
!qt!
!qt      ixv(1) = ix1
!qt      ixv(2) = ix2
!qt      iyv(1) = iy1
!qt      iyv(2) = iy2
!qt      iz = 0
!qt      iPen = iRaggio * 2
!qt      iColor = 0
!qt      ind = 4
!qt      call graphs(iz,ind,' ',iColor,iPen)
!qt!
!qt      return
!qt      end
!qt!-----------------------------------------------------------------------
!qt      subroutine LineaSfumata(ix1, iy1, ix2, iy2, iRaggio)
!qt      USE Molcom
!qt!
!qt      ixv(1) = ix1
!qt      ixv(2) = ix2
!qt      iyv(1) = iy1
!qt      iyv(2) = iy2
!qt      iPen = iRaggio * 2
!qt      ind = 6
!qt      iColor = 0
!qt      call graphs(iPen,ind,' ',iColor,iColor)
!qt!
!qt      return
!qt      end
!-----------------------------------------------------------------------
!     MISC ROUTINES
!-----------------------------------------------------------------------
      subroutine CheckRecordLength
      USE General, only: nlen
      implicit none
      integer, dimension(512) :: ivet
      integer                 :: nlenBin
!
      ivet(:) = 0
      inquire(IOLENGTH = nlenBin) ivet
      nlen = nlenBin
      return
!
      end
!corr! ----------------------------------------------------------------------
!corr      integer function getCfgDirNew(cfgdir)
!corr      USE strutil
!corr      use iso_c_binding
!corr      interface
!corr      function get_configdir_new(dirnam,lend) 
!corr     *bind(C,name="get_configdir_new")
!corr      use iso_c_binding
!corr      integer(c_int) :: get_configdir_new 
!corr      character(c_char), dimension(*) :: dirnam
!corr      integer(c_int) :: lend
!corr      end function get_configdir_new
!corr      end interface
!corr!
!corr      !character*(*) cfgdir
!corr      integer get_configdir
!corr      character(c_char), dimension(*) :: cfgdir 
!corr!
!corr      write(0,*)'NEW GETCFGDIR: ',get_configdir_new(cfgdir,lend)
!corr!
!corr      return
!corr      end
!corr
! ----------------------------------------------------------------------
!corr      integer function getCfgDir(cfgdir)
!corr      USE strutil
!corr!
!corr      character*(*) cfgdir
!corr      integer get_configdir
!corr!
!corr      getCfgDir = get_configdir(cfgdir, len(cfgdir))
!corr      if (getCfgDir == 0) cfgdir = remc0(cfgdir)
!corr      write(0,*)'cfgdir:',trim(cfgdir),len_trim(cfgdir),getCfgDir
!corr!
!corr      return
!corr      end
! ----------------------------------------------------------------------
!      integer function getCfgDir(cfgdir)
!      USE strutil
!      use iso_c_binding
!      implicit none
!      interface
!      integer function
!     *get_configdir(str,l1) bind(C, name="_Z13get_configdirPKci")
!          use iso_c_binding
!          implicit none
!          character(len=1, kind=C_CHAR) :: str(*)
!          integer(c_int) :: l1
!      end function
!      end interface
!!
!      character*(*) cfgdir
!      character(len=1, kind=C_CHAR) :: c_str(len(cfgdir) + 1)

!      !integer get_configdir
!!
!      c_str(len(cfgdir)+1) = C_NULL_CHAR
!      getCfgDir = get_configdir(c_str, len_trim(cfgdir))
!      cfgdir(1:len(cfgdir)) = c_str(1)(1:len(cfgdir))
!      if (getCfgDir == 0) cfgdir = remc0(cfgdir)
!      write(0,*)'c_str=',c_str(1)(1:len(cfgdir))
!      write(0,*)'cfgdir=',len(cfgdir),trim(cfgdir)
!      getCfgDir = 0
!!
!      return
!      end
!-----------------------------------------------------------------------
!corr      subroutine sortz(lind,numb,iblk,jump)
!corr      USE BigStore
!corr!--sort the data in store
!corr!
!corr!  lind  addres in store
!corr!  numb  number of block of data to be sorted
!corr!  iblk  block lenght of the data (i.e. number of items per block)
!corr!  jump  < 0 sort in decreasing order
!corr!  jump  > 0 sort in increasing order
!corr!  iabs(jump) = relative addres of the key of sort
!corr!
!corr      if (numb.le.1) then
!corr          return
!corr      endif
!corr      jsig=1
!corr      if (jump.lt.0) then
!corr          jump = iabs(jump)
!corr          jsig = -1
!corr      endif
!corr      jump = jump - 1
!corr      ja = 2
!corr      kVai = 1
!corr      do while (kVai.eq.1)
!corr         jb = numb / ja
!corr         if (jb.le.0) then 
!corr             jb = 1
!corr         endif
!corr         jc = numb - jb
!corr 2040    continue
!corr         jd = 0
!corr         m  = lind
!corr         do i=1,jc
!corr            mk = m + jb * iblk
!corr            if ((store(m+jump)-store(mk+jump))*jsig.gt.0) then
!corr                mm = m
!corr                mmk = mk
!corr                do je=1,iblk
!corr                   f          = store(mm)
!corr                   store(mm)  = store(mmk)
!corr                   store(mmk) = f
!corr                   mm  = mm + 1
!corr                   mmk = mmk + 1
!corr                enddo
!corr                jd = 1
!corr            endif
!corr            m = m + iblk
!corr         enddo
!corr         if (jd.gt.0) then
!corr             go to 2040
!corr         endif
!corr         if (jb.gt.1) then
!corr             ja = ja * 2
!corr         else
!corr             kVai = 0
!corr         endif
!corr      enddo
!corrc
!corr      return
!corr      end
!-----------------------------------------------------------------------
      subroutine sortz_dyn(vettore,idim,lind,numb,iblk,jump)
!
!--sort the data in vettore
!
!  vettore      array to sort
!  idim         dimension of vettore
!  lind         addres in vettore
!  numb         number of block of data to be sorted
!  iblk         block lenght of the data (i.e. number of items per block)
!  jump  < 0    sort in decreasing order
!  jump  > 0    sort in increasing order
!  iabs(jump) = relative addres of the key of sort
!
      dimension vettore(idim)
!
      if (numb.le.1) then
          return
      endif
      jsig=1
      if (jump.lt.0) then
          jump = iabs(jump)
          jsig = -1
      endif
      jump = jump - 1
      ja = 2
      kVai = 1
      do while (kVai.eq.1)
         jb = numb / ja
         if (jb.le.0) then 
             jb = 1
         endif
         jc = numb - jb
 2040    continue
         jd = 0
         m  = lind
         do i=1,jc
            mk = m + jb * iblk
            if ((vettore(m+jump)-vettore(mk+jump))*jsig.gt.0) then
                mm = m
                mmk = mk
                do je=1,iblk
                   f          = vettore(mm)
                   vettore(mm)  = vettore(mmk)
                   vettore(mmk) = f
                   mm  = mm + 1
                   mmk = mmk + 1
                enddo
                jd = 1
            endif
            m = m + iblk
         enddo
         if (jd.gt.0) then
             go to 2040
         endif
         if (jb.gt.1) then
             ja = ja * 2
         else
             kVai = 0
         endif
      enddo
c
      return
      end
!-----------------------------------------------------------------------
CORR      subroutine sort3 (alf,iorde,   numb)
CORRc--sort the e(s) respect to the g (partial structure only)
CORRc
CORR      dimension alf(*),iorde(*)
CORR      dimension wt(4000)
CORR      integer iorde
CORRc--
CORR      do 1010 i=1,numb
CORR      wt(i)=alf(i)
CORR1010  continue
CORR      int = 2
CORR1000  int = 2*int
CORR      if(int .lt. numb) go to 1000
CORR      int = min0(numb,(3*int)/4-1)
CORR1020  int = int/2
CORR      ifin = numb - int
CORR      do 1120 ii=1,ifin
CORR      i=ii
CORR      j=i+int
CORR      if(wt(i)-wt(j)) 1040,1120,1120
CORR1040  a=wt(j)
CORR      m=iorde(j)
CORR1060  wt(j)=wt(i)
CORR      iorde(j)=iorde(i)
CORR      j=i
CORR      i=i-int
CORR      if(i) 1100,1100,1080
CORR1080  if(wt(i)-a) 1060,1100,1100
CORR1100  wt(j)=a
CORR      iorde(j)=m
CORR1120  continue
CORR      if(int .gt. 1) go to 1020
CORR      return
CORR      end
!-----------------------------------------------------
      subroutine sortall(isort,x,numb)
      dimension x(numb)

c--- isort=-1 ===> descrescente
c--- isort= 1 ===> crescente

      if (numb.eq.1) return
      m=2
  10  continue
      in=numb/m
      if (in) 20,20,30
  20  continue
      in=1
  30  continue
      ifin=numb-in
  40  continue
      mark=0
      do 60 i=1,ifin
      k=i+in
      if (isort.lt.0) then
         if (x(i)-x(k)) 50,60,60
      else
         if (x(k)-x(i)) 50,60,60
      endif
  50  continue
      dd=x(i)
      x(i)=x(k)
      x(k)=dd
      mark=1
  60  continue
      if (mark) 65,65,40
  65  continue
      if (in-1) 80,80,70
  70  continue
      m=m*2
      go to 10
  80  continue
      return
      end
!-----------------------------------------------------------------------
      subroutine sort3_int(ialf, iorde, numb)
c
      integer ialf(numb), iorde(numb), a
c--
      int = 2
1000  int = 2*int
      if(int .lt. numb) go to 1000
      int = min0(numb,(3*int)/4-1)
1020  int = int/2
      ifin = numb - int
      do 1120 ii=1,ifin
      i=ii
      j=i+int
      if(ialf(i)-ialf(j)) 1040,1120,1120
1040  a=ialf(j)
      m=iorde(j)
1060  ialf(j)=ialf(i)
      iorde(j)=iorde(i)
      j=i
      i=i-int
      if(i) 1100,1100,1080
1080  if(ialf(i)-a) 1060,1100,1100
1100  ialf(j)=a
      iorde(j)=m
1120  continue
      if(int .gt. 1) go to 1020
      return
      end
!-----------------------------------------------------
      subroutine unpak3Sir(index,kod1,kod2,ifaz)
!
      isave=iabs(index)/32
      ifaz=iabs(index)-isave*32 -1
      kod1=isave/8192
      kod2=isave-8192*kod1-4096
      kod1=kod1-4096
!
      return
      end
!-----------------------------------------------------------------------
!     MATH ROUTINES
!-----------------------------------------------------------------------
      subroutine autov(a,eigen,t,icod)
      implicit real *8 (a-h,o-z)
      real *4 t(3,3),a(3,3),aik(3),eigen(3),aaa
!
      itmax=50
      n=3
      nm1=n-1
      eps1=.1e-10
      eps2=eps1
      eps3=.1e-9
      sigma1=0
      offdsq=0
      do i=1,3
         do j=1,3
            t(i,j)=0.
         enddo
      enddo
      do 5 i=1,n
      sigma1=sigma1+a(i,i)**2
      t(i,i)=1.0
      ip1=i+1
      if (i.ge.n) go to 6
      do 5 j=ip1,n
   5  offdsq=offdsq+a(i,j)**2
   6  s=2.*offdsq+sigma1
!
!  inizio iter. jacobi
!
      do 26 iter=1,itmax
      do 20 i=1,nm1
      ip1=i+1
      do 20 j=ip1,n
      q=abs(a(i,i)-a(j,j))
      if(q.le.eps1) goto 9
      if(abs(a(i,j)).le.eps2) goto 20
      p=2.*a(i,j)*q/(a(i,i)-a(j,j))
      spq=sqrt(p*p+q*q)
      csa=sqrt((1.+q/spq)/2.)
      sna=p/(2.*csa*spq)
      goto 10
    9 csa=1./sqrt(2.d0)
      sna=csa
   10 continue
!
      do k=1,n
         holdki=t(k,i)
         t(k,i)=holdki*csa+t(k,j)*sna
         t(k,j)=holdki*sna-t(k,j)*csa
      end do
!
      do k=i,n
         if(k.le.j) then
            aik(k)=a(i,k)
            a(i,k)=csa*aik(k)+sna*a(k,j)
            if(k.eq.j) then
               a(j,k)=sna*aik(k)-csa*a(j,k)
            end if
         else
            holdik=a(i,k)
            a(i,k)=csa*holdik+sna*a(j,k)
            a(j,k)=sna*holdik-csa*a(j,k)
         end if
      end do
!
      aik(j)=sna*aik(i)-csa*aik(j)
!
      do k=1,j
         if (k.le.i) then
            holdki=a(k,i)
            a(k,i)=csa*holdki+sna*a(k,j)
            a(k,j)=sna*holdki-csa*a(k,j)
         else
            a(k,j)=sna*aik(k)-csa*a(k,j)
         endif
      end do
   20 a(i,j)=0.0
!
      sigma2=0.0
      do i=1,n
         eigen(i)=a(i,i)
         sigma2=sigma2+eigen(i)**2
      end do
      if (abs(sigma2).le.1.e-07) then
         icod = 0
         return
      end if
      if (abs(sigma2).gt.1.e-07) then
         aaa = 1.0-sigma1/sigma2
         if(aaa.ge.eps3) goto 25
      end if
      icod=1
      return
   25 sigma1=sigma2
   26 continue
      icod=0
!
      return
      end
! ------------------------------------------------------------------
      subroutine besse(xx,vec)
!--bessel function
!
      x=abs(xx)
      vec=amin1((x+0.4807)*x/((x+0.8636)*x+1.3943),1.0)
      if (xx.lt.0.0) vec=-vec
      return
      end
!-----------------------------------------------------------------------
      subroutine pack (index,ih,kk,il)
      ih = index/262144
      is = index - 262144*ih
      kk = is/512-256
      il = is-512*(kk+256)-256
      return
      end
!-----------------------------------------------------------------------
      function bes(x)
      is=1
      if(x.lt.0.0) is=-1
      x1=abs(x)
      if(x1.lt.0.000001)  go to 200
      if(x1.le.2.9) go to 180
      if(x1.le.7.5) go to 160
      if(x1.le.20.) go to 140
      if(x1.le.39.) go to 120
      if(x1.le.45.) go to 100
      if(x1.le.55.) go to  80
      if(x1.le.65.) go to  60
      if(x1.le.80.) go to  40
      if(x1.le.99.) go to  20
      bes=1.*is
      return
   20 bes=0.0000631*x1+.988652
      bes=abs(bes)*is
      return
   40 bes=0.0000933*x1+.9862355
      bes=abs(bes)*is
      return
   60 bes=0.00014*x1+.9832
      bes=abs(bes)*is
      return
   80 bes=0.00021*x1+.97935
      bes=abs(bes)*is
      return
  100 bes=0.0000666*x1+.9858026
      bes=abs(bes)*is
      return
  120 bes=0.9459 +0.00187*x1-0.00002*x1*x1
      bes=abs(bes)*is
      return
  140 bes=0.82227+0.02189*x1-0.00114*x1*x1+0.00002*x1*x1*x1
      bes=abs(bes)*is
      return
  160 bes=0.444+0.19096*x1-0.02697*x1*x1+0.00135*x1*x1*x1
      bes=abs(bes)*is
      return
  180 bes=-0.00718+0.5668*x1-0.12287*x1*x1 +0.008*x1*x1*x1
      bes=abs(bes)*is
      return
  200 bes=0.
      return
      end
! ----------------------------------------------------------------------
      function besinv(y)
      if (abs(y).lt.0.000001)  go to  200
      if (y.le.0.6989)  go to 180
      if (y.le.0.8666) go to 160
      if (y.le.0.9259)  go to 140
      if (y.le.0.9553)  go to 120
      if (y.le.0.9635)  go to 100
      if (y.le.0.9884) go to 90
      if (y.le.0.9888) go to 80
      if (y.le.0.9909) go to 70
      if (y.le.0.9923) go to 60
      if (y.le.0.9937) go to 50
      if (y.le.0.9949) go to 40
      besinv=100.
      return
   40 besinv=15833.333*y-15653.583
      return
   50 besinv=10714.285*y-10566.785
      return
   60 besinv=7142.8571*y-7022.8571
      return
   70 besinv=4761.9047*y-4663.5713
      return
   80 besinv=15000*y-14787
      return
   90 besinv=49773.46954-102737.23532*y+53033.83171*y*y
      return
  100 besinv=77576.4096-162332.52722*y+84935.62155*y*y
      return
  120 besinv=3117.15834-6767.58257*y+3681.64105*y*y
      return
  140 besinv=486.69735-1127.7574*y+658.80603*y*y
      return
  160 besinv=-82.06253+344.25645*y-478.71058*y*y+226.35886*y*y*y
      return
  180 besinv=-0.00252+2.1065*y-1.12674*y*y+3.09414*y*y*y
      return
  200 besinv=0
      return
      end
!-----------------------------------------------------------------------
!     TIME ROUTINES
!-----------------------------------------------------------------------
      subroutine CPUTime(string)
      USE General
      common /cputimec/ t1vet(10),jcpuP,kopcpu
      common /tempo/ nSecs,nSecsTot
      character*(*) string
!
! Print CPU time used since last called
!
!
      T=t1vet(jcpuP)

      call cpu_time(t1)
!
      T = t1-T
      if (jcpuP.eq.1) then
          nSecsTot = nint(T)
      else
          nSecs = nint(T)
      endif
      jcpuP = jcpuP - 1
      if (jcpuP.lt.0) then
          stop "CPUTIME"
      endif
!
      return
      end
!-------------------------------------------------------------
      subroutine CPUTime0(string)
      USE General
      common /cputimec/ t1vet(10),jcpuP,kopcpu
      character*(*) string
!corr      character*10 buffer,spazio
!
! Initialize CPU time routine
!
!
      call cpu_time(t1)
      jcpuP = jcpuP + 1
      if (jcpuP.gt.10) then
          stop "CPUTIME0"
      endif
      t1vet(jcpuP) = t1
!
      return
      end
c-------------------------------------------------------------
!corr      subroutine sirtime(string,lstring)
!corr      character *(*) string
!corr!
!corr!-- if a TIME function is not available
!corr!-- tranform this subroutine in a dummy one
!corr!-- leaving only the following lines
!corr!--
!corr!--              character *(*) string
!corr!--              lstring=0
!corr!--              return
!corr!--              end
!corr!
!corr      character time*26
!corr!
!corr      call SirTm(time)
!corr      string( 1:3)='At '
!corr      string( 4:11)=time(12:19)
!corr      string(12:12)=' '
!corr      lstring=12
!corr!
!corr      return
!corr      end
!-----------------------------------------------------------------------
!corr       subroutine sirdate(string,lstring)
!corr            !USE strutil
!corr       character *(*) string
!corr !
!corr !-- if a DATE function is not available
!corr !-- tranform this subroutine in a dummy one
!corr !-- leaving only the following lines
!corr !--
!corr !--              character *(*) string
!corr !--              lstring=0
!corr !--              return
!corr !--              end
!corr !
!corr       character stringa_data*26
!corr !
!corr       string=' '
!corr       call SirTm(stringa_data)
!corr       string( 1:11)=stringa_data( 1:11)
!corr       string(12:16)=stringa_data(20:24)
!corr       call shift(string,k)
!corr       string(k+2:k+3)='at'
!corr       string(k+5:k+12)=stringa_data(12:19)
!corr       lstring=k+12
!corr       !write(0,*)'DATA=',trim(stringa_data)
!corr       !write(0,*)'DATA=',len_trim(date_time_string())
!corr       !write(0,*)'DATA=',trim(date_time_string())
!corr       !write(0,*)'TIME=',time_string()
!corr !
!corr       return
!corr       end
!-----------------------------------------------------------------------
      function jopen(ncsu,name,istat,iform,ier)
c     function jopen(ncsu,name,nlen,istat,iform,ier)
!--connect a unit to an external file
!  file properties:
!  sequential
!  formatted
!  ncsu = number identifies the unit
!  name = file name
!ccccc  nlen = maximum length in bytes for formatted records
!  istat = 0 means status unknown
!        = 1 means status scratch
!        = 2 means status old
!  iform = 1 means formatted
!        = 2 means unformatted
!  ier  = integer variable to receive a status indicator
!--
      character *(*) name
      character form(2)*11
!
               !write(0,*)'unit=',ncsu,'name=',trim(name)
      form(1)='formatted  '
      form(2)='unformatted'
      jopen=0
      jump=istat+1
      if(iform.eq.2)go to 5000
      go to (1000,2000,3000),jump
 1000 continue
!-- status = 'unknown'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='unknown',form=form(iform))
      go to 8000
 2000 continue
!-- status = 'scratch'
      open(unit=ncsu,iostat=ier,err=9000,
     1 status='scratch',form=form(iform))
      go to 8000
 3000 continue
!-- status = 'old'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='old',form=form(iform))
      go to 8000
5000  continue
      go to (1100,2100,3100),jump
 1100 continue
!-- status = 'unknown'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='unknown',form=form(iform))
      go to 8000
 2100 continue
!-- status = 'scratch'
      open(unit=ncsu,iostat=ier,err=9000,
     1 status='scratch',form=form(iform))
      go to 8000
 3100 continue
!-- status = 'old'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='old',form=form(iform))
 8000 continue
      rewind ncsu
      return
9000  jopen=-1
      return
      end
!-----------------------------------------------------------------------
      function kopen(ncsu,name,nlen,itype,ier)
!--connect a unit to an external file
!  file properties:
!  direct
!  unformatted
!  ncsu = number identifies the unit
!  name = file name
!  nlen = length in bytes for the records
!  itype = 0 means status unknown
!        = 1 means status scratch
!        = 2 means status old
!  ier  = integer variable to receive a status indicator
!--
      character *(*) name
      kopen=0
      itype=itype+1
      goto(1000,2000,3000),itype
1000  continue
!  **machine specific open file
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     * status='unknown',access='direct',
!vax 1 recordtype='fixed',
     2 form='unformatted',recl=nlen)
      return
2000  continue
!  **machine specific open file
!dg  file name is given by the compiler
      open(unit=ncsu,iostat=ier,err=9000,
     * status='scratch',access='direct',
!vax 1 recordtype='fixed',
     2 form='unformatted',recl=nlen)
      return
3000  continue
!  **machine specific open file
!dg  file name is given by the compiler
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     * status='old',access='direct',
!vax 1 recordtype='fixed',
     2 form='unformatted',recl=nlen)
      return
9000  kopen=-1
      return
      end
!-----------------------------------------------------------------------
!     STRING MANIPULATION ROUTINES
!-----------------------------------------------------------------------
      subroutine ucase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
!
      k = len(line)
      do i=1,k
         a = line(i:i)
         l = 0
         do j=1,26
            if (a.eq.ulc(j:j)) then
                l = j
            endif
         enddo
         if (l.ne.0) then
             line(i:i) = ulc(l+26:l+26)
         endif
      enddo
c
      return
      end
!----------------------------------------------------------------------
      subroutine lcase(line)
      character*(*) line
      character*52 ulc
      common /ulcase/ ulc
      character a
!
      k = len(line)
      do i=1,k
         a = line(i:i)
         l = 0
         do j=27,52
            if (a.eq.ulc(j:j)) then
                l = j
            endif
         enddo
         if (l.ne.0) then
             line(i:i) = ulc(l-26:l-26)
         endif
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine filtra(string)
      character*(*) string
!
      k = Lung(string)
      if (k.gt.0) then
          if (ichar(string(k:k)).eq.13) then
              string(k:k) = ' '
          endif
      endif
!
      return
      end
!----------------------------------------------------------------------
      subroutine getnum(linei,vet,ivet,iv,iopt)
      USE General
!
      dimension vet(40),ivet(40)
      character(len=*) :: linei
      character(len=len(linei)) :: resto,cifre
!      character linei*(*),resto*80,cifre*80
c
c-- CTRL-M filter
c
      call filtra(linei)
c        
      iv=0
      iopt=0
      do i=1,40
         vet(i)=0.0
         ivet(i)=0
      enddo
      k=len(linei)
!corr      do i=1,80
!corr         resto(i:i)=blank
!corr      enddo
      do i=1,k
         resto(i:i)=linei(i:i)
      enddo
    5 sum=0.0
      isum=0
      call cutst(resto,ncharl,cifre,nchard)
      if (nchard.le.0) return
      segno=1.0
      isegno=1
      iniz=1
      if (cifre(1:1).eq.digit(12:12)) then
          segno=-1.0
          isegno=-1
          iniz=2
      endif
      ipoi=index(cifre(1:nchard),digit(11:11))
      if (ipoi.eq.0) ipoi=nchard+1
      dec=ipoi-1-iniz
      idec=ipoi-1-iniz
      do i=iniz,nchard
         idig=index(digit,cifre(i:i))
         if (idig.ge.1.and.idig.le.11)  then
             if (idig.le.10)  then
                 !sum=sum+float(idig-1)*10.0**dec
                 sum=sum+float(idig-1)*10**dec
                 if (idec.ge.0) isum=isum*10+(idig-1)
                 dec=dec-1.0
                 idec=idec-1.0
             endif
         else
             iopt=-1
             return
         endif
      enddo
      iv=iv+1
      vet(iv)=sum*segno
      ivet(iv)=isum*isegno
      if (ncharl.le.0) then
          iopt=1
          return
      endif
      if (iv.eq.iopt) return
      go to 5
      end
!-----------------------------------------------------------------------
      subroutine shift(string,lenp)
      USE General
!
      character string*(*)
!
      k=len(string)
!
!-- TAB filter
!
      do i=1,k
         j = ichar(string(i:i))
c--	 if (j.eq.9) then
!!mr     if (j.lt.32.or.j.ge.127) then
         if (j.lt.32) then
             string(i:i)=blank
         endif
      enddo
      ifin=1
      do 10 i=1,k
      if (string(i:i).ne.blank) then
          iniz=i
          go to 20
      endif
   10 continue
      lenp=-1
      return
   20 do 30 i=k,1,-1
         if (string(i:i).ne.blank) then
             ifin=i
             go to 40
         endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
      if (iniz.eq.1) then
          return
      endif
      do i=1,lenp
         j=iniz+i-1
         string(i:i)=string(j:j)
      enddo
      if (lenp.eq.k) return
      do i=lenp+1,k
         string(i:i)=blank
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine cutst(string,lens,dire,lend)
      USE General
!
      character string*(*),dire*(*)
!
      k=len(dire)
      do i=1,k
         dire(i:i)=blank
      enddo
      k=len(string)
      do 10 i=1,k
      if (string(i:i).eq.blank) then
          iniz1=i
          go to 20
      endif
   10 continue
   20 continue
      lend=min0(iniz1-1,80)
      do i=1,lend
         dire(i:i)=string(i:i)
         string(i:i)=blank
      enddo
      call shift(string,lens)
c
      return
      end
!-----------------------------------------------------------------------
!qt      function LenInPix(str, Size)
!qt      USE Molcom
!qt!
!qt      character *(*) str
!qt      integer Size
!qt!
!qt      ixv(1) = Size
!qt      ind = 70
!qt      iz = Lung(str)
!qt      call graphs(iz, ind, str, 0, 0)
!qt      LenInPix = ixv(1)
!qt!
!qt      return
!qt      end
!qt!-----------------------------------------------------------------------
!qt      function LenInPix2(str,nChars, Size)
!qt      USE Molcom
!qt!
!qt      character *(*) str
!qt      integer Size
!qt      character *128 tmp
!qt!    
!qt      ixv(1) = Size
!qt      if (nChars.ne.0) then
!qt         tmp = str(1:nChars)
!qt      else
!qt         tmp = str
!qt      end if
!qt!
!qt      ind = 70
!qt      iz = Lung(tmp)
!qt      call graphs(iz, ind, tmp, 0, 0)
!qt      LenInPix2 = ixv(1)
!qt!
!qt      return
!qt      end
! ----------------------------------------------------------------------
      subroutine CentraStr(icode,nchar,linea,stringa)
      USE General
      USE strutil, only: Lung
      implicit none
      character *(*) linea,stringa
      integer :: lstringa, nchar, k, icode
!
      lstringa = Lung(stringa)
      k = 1 + ( nchar - lstringa ) / 2
      linea = ' '
      linea(k:k+lstringa-1) = stringa
      if (icode.ne.2222) write(lo,80) linea(1:nchar)
   80 format(2x,'*',a,'*')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ltrim(tmp)
      character *(*)tmp
      character *400 tmp2
!
      iz = 1
   10 if (tmp(iz:iz) .eq. ' ') then
         iz = iz + 1
         if (iz.lt.len(tmp)) goto 10
      end if
!
      tmp2 = tmp(iz:)
      tmp = tmp2
      return
      end
!------------------------------------------------------------------------
      function Valore(string)
      character *(*) string, char *1
!
      call shift(string,L)
      if (string(1:1).eq.'-') then
          string(1:1) = ' '
          call shift(string,L)
          segno = -1.0
      elseif (string(1:1).eq.'+') then
          string(1:1) = ' '
          call shift(string,L)
          segno =  1.0
      else
          segno =  1.0
      endif
      L = Lung(string)
      i = 1
      Valore = 0.0
      if (L.eq.0) then
          return
      endif
   10 if (string(i:i) .eq. ' ') then
         if (i .eq. L) then
            return
         end if
         i = i + 1
         goto 10
      end if
      k = ichar('0')
      idec = 0
      exp = 1
      do 100 j=i, L
         char = string(j:j)
         if(char .eq. '.') then
            idec = 1
            goto 100
         end if
         v = ichar(string(j:j)) - k
         if (idec .ne. 0) then
            exp = exp / 10.
            Valore = Valore + v * exp
         else
            Valore = Valore * 10. + v
         end if
  100 continue
      Valore = Valore * segno
      return
      end
!-----------------------------------------------------------------------
      subroutine CutStr(tmp, iz)
      USE fileutil
      implicit none
      character *(*)tmp
      integer :: iz
!
   10 if (tmp(iz:iz).ne.' '.and.tmp(iz:iz).ne.get_separ()) then
         if (iz.gt.1) then
            iz = iz - 1
            goto 10
         end if
      end if
!
      iz = iz - 1
      return
      end
! ----------------------------------------------------------------------
      function Lung (Stringa)
!
      character  Stringa *(*)

      K = len (Stringa)
      do 10 I = K, 1, -1
	    num = ichar(Stringa(I:I))
!          if (Stringa(I:I) .NE. ' ') then
          if (num.ne.32.and.num.ne.0) then
             Lung = I
             return
          end if
   10 continue
      Lung = 0
!
      return
      end
!----------------------------------------------------------------------
      subroutine CheckSpaceGroupSymbol(symbol, ier)
      USE General
      USE Symmetry
!
      dimension ivet(40), vet(40)
      character symbol*16, newsymbol*13, line*13, newline*13
!
      ier = 0
      nSpaceGroup = 0
      nSpaceGroupPatt = 0
!
!-- Convert Space Group Symbol in lower case character string
!
      call lcase(symbol)
      if (symbol(1:1) == 'h') then
          symbol(1:1) = 'r'
      endif
!
!-- Check if Space Group Code has been supplied
!
      iopt = 0
      call getnum(symbol,vet,ivet,iv,iopt)
      if (iopt /= -1 .and. iv == 1) then
          Code = ivet(1)
          if ((Code > 0) .and. (Code < 231)) then
              istat = 2
              iform = 1
              jop = jopen(kform, iasun, istat, iform, ier)
              read(kform,'(a13)') line
              if (line(1:3) == 'p 1') then
                  nLinesLaue = 0
              else
                  nLinesLaue = 26
              endif
              rewind kform
              if (nLinesLaue > 0) then
                  do i=1, nLinesLaue
                     read(kform,'(a13)') line
                  enddo
              endif
              do
                 read(kform,'(a13,i2,i5)') line, kp, kf
                 if (Code == kf) then
                     symbol = line
                     nSpaceGroup = kf
                     nSpaceGroupPatt = kp
                     exit
                 endif
              enddo
              close(kform)
!corr              read(symbol,'(16a1)') DummySpaceGr(1:16)
              return
          endif
      endif

!
!-- First check on Space Group Symbol conversion from
!-- International Table (1983) into the notation used in
!-- International Table (1974).
!
!corr      if (symbol(5:6).eq.'-3') then
!corr          symbol = symbol(1:4) // '3' // symbol(7:16) // ' '
!corr      endif
      istat = 2
      iform = 1
      jop = jopen(kform, iasun, istat, iform, ier)
      read(kform,'(a13)') line
      if (line(1:3) == 'p 1') then
          nLinesLaue = 0
      else
          nLinesLaue = 26
      endif
      rewind kform
      if (nLinesLaue > 0) then
          do i=1, nLinesLaue
             read(kform,'(a13)') line
          enddo
      endif
!
!-- Check Space Group Symbol as it is
!
      iOK = 0
      do
         read(kform,'(a13,i2,i5)') line, kp, kf
         if (line(1:4) == '$$$$') then
             exit
         endif
         if (line == symbol(1:13)) then
             iOK = 1
             nSpaceGroup = kf
             nSpaceGroupPatt = kp
             exit
         endif
      enddo
      if (iOK == 0) then
          newsymbol(1:13) = symbol(1:13)
!
!-- Strip out parenthesis (if any)
!
          k1 = index(newsymbol, '(')
          if (k1 > 0) then
              k2 = k1
              do while (k1 > 0 .or. k2 > 0)
                 if (k1 > 0) newsymbol(k1:k1) = ' '
                 if (k2 > 0) newsymbol(k2:k2) = ' '
                 k1 = index(newsymbol, '(')
                 k2 = index(newsymbol, ')')
              enddo
          endif
!
          call NoBlanks(newsymbol, ls)
!
!-- Second check on Space Group Symbol conversion
!
!corr          if (newsymbol(3:4).eq.'-3') then
!corr              newsymbol = newsymbol(1:4) // '3' // newsymbol(7:13) //' '
!corr              ls = ls - 1
!corr          endif
!
!-- Check Space Group Symbol ( blanks stripped )
!
          rewind kform
          if (nLinesLaue > 0) then
              do i=1, nLinesLaue
                 read(kform,'(a13)') line
              enddo
          endif
          do
             read(kform,'(a13,i2,i5)') line, kp, kf
             if (line(1:4) == '$$$$') then
                 exit
             endif
             newline = line
             call NoBlanks(newline, ls)
             if (newline == newsymbol(1:13)) then
                 iOK = 1
                 nSpaceGroup = kf
                 nSpaceGroupPatt = kp
                 exit
             endif
          enddo
          if (iOK == 1) then
              symbol = line
          endif
      endif
      ier = 0
      lenp = 16
      call onebl(symbol,lenp,ier)
!
      close(kform)
!corr      read(symbol,'(16a1)') DummySpaceGr(1:16)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StandardSPG(string, ier)
      USE Symmetry, only: nSpaceg
!
!-- Make Space Group Symbol standard 
!
      implicit none
      character(len=*) :: string
      integer          :: ier
!
      call CheckSpaceGroupSymbol(string, ier)
      if (ier == 0) read(string,'(16a1)') nSpaceG
      return
!
      end
!-----------------------------------------------------------------------
      subroutine OneBlankOnly(String)
      USE General
!
!-- Check that only one blank is between two symmetry operators
!
      character*(*) String
!
      ls = Lung(String)
      k = 9999
      do while (k > 0)
         k = index(String(1:ls), '  ')
         if (k > 0) then
             Buffer1 = ' '
             Buffer1(1:k) = String(1:k)
             Buffer1(k+1:) = String(k+2:)
             String = ' '
             ls = ls - 1
             String(1:ls) = Buffer1(1:ls)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MoltMatVec(a, b, c)
      dimension a(3, 3), b(3), c(3)
!
! ---  matrix * vector
!
      do i=1, 3
         c(i) = 0
         do j=1, 3
            c(i) = c(i) + a(i,j) * b(j)
         enddo
      enddo
!
      return
      end
! ------------------------------------------------------------------
      subroutine MoltVecMat(a, b, c)
      dimension a(3, 3), b(3), c(3)
!
! --- vector * matrix
!
      do j=1, 3
         c(j) = 0
         do i=1, 3
            c(j) = c(j) + b(i) * a(i,j)
         enddo
      enddo
!
      return
      end
! --------------------------------------------------------------------
      subroutine MoltMatMat(b, du, w)
      dimension b(3,3), du(3,3), w(3,3)
!
! ---  matrix * matrix
!
      do i = 1 , 3
         do j = 1 , 3
            dum = 0
            do K = 1 , 3
               dum = dum + b(i, K) * du(K, j)
            enddo
            w(i, j) = dum
         enddo
      enddo
!
      return
      end
